/*
 * z2-Environment
 * 
 * Copyright(c) ZFabrik Software GmbH & Co. KG
 * 
 * contact@zfabrik.de
 * 
 * http://www.z2-environment.eu
 */
package com.zfabrik.components.provider.fs;

import com.zfabrik.components.provider.util.FSComponentExtRepositoryDB;
import com.zfabrik.components.provider.util.FSComponentRepositoryHelper;

/**
 * A multi root storing component repo db. It's components have a string root information
 * identifying paths to check for.
 * This is used to implement for example the multi-root feature of the GitCR.
 * We declare a class here so that the {@link FSComponentRepositoryHelper} has a class as class loading reference
 * during de-serialization of the repo DB.
 */
public class MultiRootFSComponentRepositoryDB extends FSComponentExtRepositoryDB<RootBoundFSCRComponent>{
	private static final long serialVersionUID = 1L;
	
	@Override
	protected RootBoundFSCRComponent createSyntheticComponent(String componentName) {
		return new RootBoundFSCRComponent(componentName);
	}
}
